<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <link rel="stylesheet" type="text/css" href="stlye.css">
    <link rel="stylesheet" href="https://cdn.jsdelivr.net/npm/bootstrap@4.6.1/dist/css/bootstrap.min.css" integrity="sha384-zCbKRCUGaJDkqS1kPbPd7TveP5iyJE0EjAuZQTgFLD2ylzuqKfdKlfG/eSrtxUkn" crossorigin="anonymous">
    <title>CSS and Bootstrap Flex</title>
</head>
<body>
    <div class="container-fluid text-center">
        <h1>Bootstrap Flex</h1>
        <p>use the d-flex class to create a flex 
            container and transform direct children
             into flex items</p>

             <h2> Centering our Elements</h2>
             <!--  -->
             <div style="height: 500px;" class="bg-secondary p-3 d-flex justify-content-center
             align-items-center flex-column-reverse">
             <!-- flex-direction-column default row -->
                <!-- only apply to its direct child, grandchildren not included. -->
                <div class="h-25 p-3 bg-success">Flex Item A</div>
                <div class="h-25 p-3 bg-warning">Flex Item B</div>
                <div class="h-25 p-3 bg-danger">Flex Item C</div>
             </div>

        <h2>Flex Row</h2>
        <div class="bg-dark p-3 d-flex flex-row">
            <div class="p-3 bg-success">Flex A</div>
            <div class="p-3 bg-danger">Flex B</div>
            <div class="p-3 bg-warning">Flex C</div>
        </div>

        <h2>Flex Row Reverse</h2>
        <div class="bg-dark p-3 d-flex flex-row-reverse">
            <div class="p-3 bg-success">Flex A</div>
            <div class="p-3 bg-danger">Flex B</div>
            <div class="p-3 bg-warning">Flex C</div>
        </div>

        <h2>Creating Space Between Elements</h2>
        <div class="bg-dark p-3 d-md-flex justify-content-around">
            <!-- only apply in medium screen -->
            <!-- when md indicated in d-flex it will only effect on md size screen to up -->
            <div class="p-3 bg-success col-md-2">Card A</div>
            <div class="p-3 bg-danger col-md-2">Card B</div>
            <div class="p-3 bg-warning col-md-2">Card C</div>
            <!-- 768 is meduim -->
        </div>

        <h2>Flexbox with Margin </h2>
        <!-- Good for nav bar display -->
        <div class="bg-dark p-3 d-flex">
            <div class="p-3 bg-success  mr-auto">Flex Item A</div>
            <div class="p-3 bg-warning">Flex Item B</div>
            <div class="p-3 bg-danger">Flex Item C</div>
            <div class="p-3 bg-primary">Flex Item D</div>
        </div>

        <h2>Nested Flex Elements</h2>
        <!-- d-block applicable to all scree size coz its not specified -->
        <div class="bg-dark p-3 d-block d-md-flex">
            <div class="p-3 bg-success mr-auto">Flex Item A</div>
            <!-- space between the elements -->
            <div class="w-50 d-block d-md-flex justify-content-between">
                <!-- grandchildren B, C, D -->
                <div class="p-3 bg-warning">Flex Item B</div>
                <div class="p-3 bg-danger">Flex Item C</div>
                <div class="p-3 bg-primary">Flex Item D</div>
            </div>
        </div>


    </div>


    <script src="https://cdn.jsdelivr.net/npm/jquery@3.5.1/dist/jquery.slim.min.js" integrity="sha384-DfXdz2htPH0lsSSs5nCTpuj/zy4C+OGpamoFVy38MVBnE+IbbVYUew+OrCXaRkfj" crossorigin="anonymous"></script>
    <script src="https://cdn.jsdelivr.net/npm/bootstrap@4.6.1/dist/js/bootstrap.bundle.min.js" integrity="sha384-fQybjgWLrvvRgtW6bFlB7jaZrFsaBXjsOMm/tB9LTS58ONXgqbR9W8oWht/amnpF" crossorigin="anonymous"></script>
</body>
</html>